<template>
  <AppModal
    v-if="showModal"
    :closing-cross="true"
    :no-default="true"
    class="album-gift-modal"
    @close="closeModal"
  >
    <template v-slot:header>
      <div class="dismiss-gift">
        <a href="#" @click="skipGift">{{
          $t('modal.albumGift.chooseLater')
        }}</a>
      </div>
      <h2 class="heading--lg heading--primary heading--uppercase">
        {{ $t('modal.albumGift.title') }}
      </h2>
      <h3 class="heading--md heading--primary heading--uppercase">
        {{ $t('modal.albumGift.subtitle') }}
      </h3>
    </template>
    <template v-slot:body>
      <Loader :display="loading" />
      <div v-if="!loading && albums.length > 0" class="albums-list">
        <ul>
          <li v-for="album in albums" :key="album.id">
            <figure>
              <img :src="getCover(album)" :alt="album.title" />
            </figure>
            <AppButton
              class="choose-album"
              :album="album.id"
              @click="chooseAlbum(album)"
              >{{ $t('modal.albumGift.btnValidate') }}</AppButton
            >
            <div>
              <h4 class="heading--sm heading--primary">
                <span style="font-weight: normal">{{ getType(album) }}</span>
                {{ album.serieName }}
              </h4>

              <StarRank
                :avgstar="album.rate.toString()"
                :countnote="album.rateAmount.toString()"
              />

              <p>
                {{ getSynopsis(album.synopsis) }}
              </p>
            </div>
            <AppButton
              class="choose-album-mobile"
              :album="album.id"
              @click="chooseAlbum(album.id)"
              >{{ $t('modal.albumGift.btnValidate') }}</AppButton
            >
          </li>
          <hr />
        </ul>
        <p>{{ $t('modal.albumGift.info') }}</p>
      </div>
    </template>
  </AppModal>
</template>

<script>
import AppModal from '@/components/ui/AppModal'
import Loader from '@/components/ui/Loader'
import AppButton from '@/components/ui/AppButton'
import StarRank from '@/components/ui/StarRank'

export default {
  name: 'AlbumGiftModal',
  components: { StarRank, AppButton, Loader, AppModal },
  data() {
    return {
      showModal: true,
      loading: true,
      albums: []
    }
  },
  async mounted() {
    this.$utils.gtmEvent({
      event: 'gtm.event',
      EventCategory: 'PopIn',
      EventAction: 'Premiere-lecture',
      EventLabel: 'Affichage_Choix-album'
    })
    const data = await this.$api.getAlbumsGift()
    if (data) {
      this.albums = data
      this.loading = false
    }
  },
  methods: {
    getCover(album) {
      return `/${this.$i18n.locale}/images/album/${album.ean}-w148xh189.jpg?v=${album.version}`
    },
    getSynopsis(synopsis) {
      let text = synopsis
      if (text.length > 100) {
        text = synopsis.slice(0, 101)
        text =
          synopsis.substr(0, Math.min(text.length, text.lastIndexOf(' '))) +
          '...'
      }
      return text
    },
    getType(album) {
      if (album.chapter != null || album.chapter === '0') {
        return this.$t('common.albumTitles.chapter') + ' ' + album.chapter
      } else if (album.volume != null || album.volume === '0') {
        return this.$t('common.albumTitles.volume') + ' ' + album.volume
      } else {
        return this.$t('common.albumTitles.episode') + ' ' + album.volume
      }
    },
    chooseAlbum(album) {
      this.$utils.gtmEvent({
        event: 'gtm.event',
        EventCategory: 'PopIn',
        EventAction: 'Premiere-lecture',
        EventLabel: `Clic_${album.title}`
      })
      this.$api.saveUserAlbumGift(album.id)
      this.showModal = false
      this.$emit('display-modal')
    },
    skipGift() {
      this.$api.skipAlbumGift()
      this.showModal = false
      this.$emit('display-modal')
    },
    closeModal() {
      this.$store.dispatch('hideCookieModal', 'album-gift')
      this.showModal = false
      this.$emit('display-modal')
    }
  }
}
</script>

<style lang="scss">
.album-gift-modal {
  .modal-wrapper {
    width: 900px;
    @media (max-width: 768px) {
      padding: 0 1rem;
      min-width: inherit;
      width: 100%;
    }
  }

  .heading--lg {
    display: inline-block;
  }

  .dismiss-gift {
    text-align: right;
  }

  .albums-list {
    margin: 15px;

    figure {
      display: inline-block;
      img {
        width: 150px;
        height: 200px;
      }
    }

    ul {
      .button {
        float: right;
      }

      .choose-album-mobile {
        display: none;
      }

      @include screen-size(md) {
        .choose-album {
          display: none;
        }
        .choose-album-mobile {
          display: block;
          float: none;
        }
      }

      li {
        text-align: left;
        padding: 10px;
        border-bottom: 1px solid black;
        :last-child {
          border-bottom: none;
        }
      }

      height: 500px;
      overflow: hidden;
      overflow-y: scroll;
    }
  }
}
</style>
